Loading...
Searching...
No Matches
Sip_accept_contact

## Macros

#define | sip_accept_contact(sip)
| Access a SIP Accept-Contact header structure sip_accept_contact_t from sip_t.
#define | SIP_ACCEPT_CONTACT_INIT()
| Initializer for structure sip_accept_contact_t.
#define | SIPTAG_ACCEPT_CONTACT(x)
| Tag list item for pointer to a Accept-Contact header structure sip_accept_contact_t.
#define | SIPTAG_ACCEPT_CONTACT_REF(x)
| Tag list item for reference to a Accept-Contact header pointer.
#define | SIPTAG_ACCEPT_CONTACT_STR(s)
| Tag list item for string with Accept-Contact header value.
#define | SIPTAG_ACCEPT_CONTACT_STR_REF(x)
| Tag list item for reference to a Accept-Contact header string.

## Typedefs

typedef struct sip_caller_prefs_s | sip_accept_contact_t
| @

## Functions

issize_t | sip_accept_contact_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Accept-Contact header.
issize_t | sip_accept_contact_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Accept-Contact header.
sip_accept_contact_t * | sip_accept_contact_init (sip_accept_contact_t x[1])
| Initialize a structure sip_accept_contact_t.
int | sip_is_accept_contact (sip_header_t const *header)
| Test if header object is instance of sip_accept_contact_t.
sip_accept_contact_t * | sip_accept_contact_dup (su_home_t *home, sip_accept_contact_t const *hdr))
| Duplicate a list of Accept-Contact header header structures sip_accept_contact_t.
sip_accept_contact_t * | sip_accept_contact_copy (su_home_t *home, sip_accept_contact_t const *hdr))
| Copy a list of Accept-Contact header header structures sip_accept_contact_t.
sip_accept_contact_t * | sip_accept_contact_make (su_home_t *home, char const *s))
| Make a Accept-Contact header structure sip_accept_contact_t.
sip_accept_contact_t * | sip_accept_contact_format (su_home_t *home, char const *fmt,...)))
| Make a Accept-Contact header from formatting result.

## Variables

msg_hclass_t | sip_accept_contact_class []
| Header class for Accept-Contact header.
tag_typedef_t | siptag_accept_contact
| Tag for Accept-Contact header object.
tag_typedef_t | siptag_accept_contact_str
| Tag for string with Accept-Contact header value.

## Detailed Description

## Macro Definition Documentation

## SIP_ACCEPT_CONTACT_INIT

#define SIP_ACCEPT_CONTACT_INIT | ( |  | ) |

Initializer for structure sip_accept_contact_t.

A static sip_accept_contact_t structure for Accept-Contact header must be initialized with the SIP_ACCEPT_CONTACT_INIT() macro. For instance,

sip_accept_contact_t sip_accept_contact = SIP_ACCEPT_CONTACT_INIT;
SIP_ACCEPT_CONTACT_INIT
#define SIP_ACCEPT_CONTACT_INIT()
Initializer for structure sip_accept_contact_t.
Definition sip_protos.h:3718
sip_accept_contact
#define sip_accept_contact(sip)
Access a SIP Accept-Contact header structure sip_accept_contact_t from sip_t.
Definition sip_protos.h:3701
sip_accept_contact_t
struct sip_caller_prefs_s sip_accept_contact_t
@
Definition sip.h:182

## SIPTAG_ACCEPT_CONTACT

#define SIPTAG_ACCEPT_CONTACT | ( |  | x | ) |

Tag list item for pointer to a Accept-Contact header structure sip_accept_contact_t.

The SIPTAG_ACCEPT_CONTACT() macro is used to include a tag item with a pointer to a sip_accept_contact_t structure in a tag list.

Parameters

  x | pointer to a sip_accept_contact_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_ACCEPT_CONTACT_REF().

## SIPTAG_ACCEPT_CONTACT_STR

#define SIPTAG_ACCEPT_CONTACT_STR | ( |  | s | ) |

Tag list item for string with Accept-Contact header value.

The SIPTAG_ACCEPT_CONTACT_STR() macro is used to include a tag item with a string containing value of a sip_accept_contact_t header in a tag list.

Parameters

  s | pointer to a string containing Accept-Contact header value, or NULL.

The string in SIPTAG_ACCEPT_CONTACT_STR() can be converted to a sip_accept_contact_t header structure by giving the string s has second argument to function sip_accept_contact_make().

The corresponding tag taking reference parameter is SIPTAG_ACCEPT_CONTACT_STR_REF().

## Typedef Documentation

## sip_accept_contact_t

typedef struct sip_caller_prefs_s sip_accept_contact_t

@

The Accept-Contact syntax is defined in RFC 3841 section 10 as follows:

Accept-Contact = ("Accept-Contact" / "a") HCOLON ac-value
*(COMMA ac-value)
ac-value = "*" *(SEMI ac-params)
ac-params = feature-param / req-param
/ explicit-param / generic-param
;;feature param from RFC 3840
;;generic-param from RFC 3261
req-param = "require"
explicit-param = "explicit"

Despite the BNF, there MUST NOT be more than one req-param or explicit-param in an ac-params. Furthermore, there can only be one instance of any feature tag in feature-param.

See also
  RFC 3840, RFC 3841, sip_contact_accept(), sip_contact_score().

The parsed Accept-Contact header is stored in sip_accept_contact_t structure.

The structure sip_accept_contact_t contains representation of SIP Accept-Contact header.

The sip_accept_contact_t is defined as follows:

typedef struct caller_prefs_s {
sip_common_t cp_common[1]; // Common fragment info
sip_caller_prefs_t *cp_next; // Link to next ac-value
msg_param_t const *cp_params; // List of parameters
char const *cp_q; // Priority
unsigned cp_require :1; // Shortcut to "require" parameter
unsigned cp_explicit :1; // Shortcut to "explicit" parameter
} sip_accept_contact_t;
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121

## Function Documentation

## sip_accept_contact_copy()

sip_accept_contact_t * sip_accept_contact_copy | ( | su_home_t * | home,
|  | sip_accept_contact_t const * | hdr )

inline

Copy a list of Accept-Contact header header structures sip_accept_contact_t.

The function sip_accept_contact_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  accept_contact = sip_accept_contact_copy(home, sip->sip_accept_contact);
  sip_accept_contact_copy
  sip_accept_contact_t * sip_accept_contact_copy(su_home_t *home, sip_accept_contact_t const *hdr))
  Copy a list of Accept-Contact header header structures sip_accept_contact_t.
  Definition sip_protos.h:3848

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_accept_contact_dup()

sip_accept_contact_t * sip_accept_contact_dup | ( | su_home_t * | home,
|  | sip_accept_contact_t const * | hdr )

inline

Duplicate a list of Accept-Contact header header structures sip_accept_contact_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  accept_contact = sip_accept_contact_dup(home, sip->sip_accept_contact);
  sip_accept_contact_dup
  sip_accept_contact_t * sip_accept_contact_dup(su_home_t *home, sip_accept_contact_t const *hdr))
  Duplicate a list of Accept-Contact header header structures sip_accept_contact_t.
  Definition sip_protos.h:3805

Returns
  A pointer to the newly duplicated sip_accept_contact_t header structure, or NULL upon an error.

## sip_accept_contact_format()

sip_accept_contact_t * sip_accept_contact_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Accept-Contact header from formatting result.

Make a new sip_accept_contact_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_accept_contact_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_accept_contact_init()

sip_accept_contact_t * sip_accept_contact_init | ( | sip_accept_contact_t | x[1] | ) |

inline

Initialize a structure sip_accept_contact_t.

An sip_accept_contact_t structure for Accept-Contact header can be initialized with the sip_accept_contact_init() function/macro. For instance,

sip_accept_contact_t sip_accept_contact;
sip_accept_contact_init(&sip_accept_contact);
sip_accept_contact_init
sip_accept_contact_t * sip_accept_contact_init(sip_accept_contact_t x[1])
Initialize a structure sip_accept_contact_t.
Definition sip_protos.h:3736

## sip_accept_contact_make()

sip_accept_contact_t * sip_accept_contact_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Accept-Contact header structure sip_accept_contact_t.

The function sip_accept_contact_make() makes a new sip_accept_contact_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_accept_contact_t header structure, or NULL upon an error.

## sip_is_accept_contact()

int sip_is_accept_contact | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_accept_contact_t.

Check if the header class is an instance of Accept-Contact header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header accept_contact
  0 | (false) otherwise

## Variable Documentation

## sip_accept_contact_class

msg_hclass_t sip_accept_contact_class[]

extern

Header class for Accept-Contact header.

The header class sip_accept_contact_class defines how a SIP Accept-Contact header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_accept_contact_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.